// actclientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "actcli.h"
#include "actDlg.h"
#include "actflds.h"

#include "actole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CActclientDlg dialog

CActclientDlg::CActclientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CActclientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CActclientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CActclientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CActclientDlg)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CActclientDlg, CDialog)
	//{{AFX_MSG_MAP(CActclientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LIST_CONTACTS,	OnListContacts)
	ON_BN_CLICKED(IDC_LIST_CNT4GRP,		OnListContactsForGroup)
	ON_BN_CLICKED(IDC_LIST_GROUPS,		OnListGroups)
	ON_BN_CLICKED(IDC_LIST_ACTIVITIES,	OnListActivities)
	ON_BN_CLICKED(IDC_ADD_EMAIL,		OnAddEmail)
	ON_BN_CLICKED(IDC_ADDUSER, OnAdduser)
	//}}AFX_MSG_MAP
//	ON_BN_CLICKED(IDC_BUTTON8, OnSetPhoneNumberWithFormatTest)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CActclientDlg message handlers

BOOL CActclientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CActclientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CActclientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CActclientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// List all the contacts in the database
void CActclientDlg::OnListContacts() 
{	
	try
	{
		COleException *pException;

		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");

		m_ListBox.ResetContent();

		if( Database.GetIsOpen() )			
		{							
			// Get & Attach Contact Object
			IContact Contact;
			LPDISPATCH contactDispatch = Database.GetContact();
			Contact.AttachDispatch(contactDispatch, TRUE);

			m_ListBox.AddString("----------------------");				
			m_ListBox.AddString("List of Contacts");					
			m_ListBox.AddString("----------------------");				
			Contact.MoveFirst();			
			while( !Contact.GetIsEOF() )
			{
				CString szOutput, szOutput1, szOutput2;
				ConvertVariantToString (Contact.GetData(CF_Name), szOutput1);
				ConvertVariantToString (Contact.GetData(CF_Company), szOutput2);
				szOutput = szOutput1 + "  " + szOutput2;
				m_ListBox.AddString( szOutput );	
				Contact.MoveNext();			
			}
			m_ListBox.AddString("----------------------");
			
			// Release Contact Object
			Contact.ReleaseDispatch();

			// Close & Release Database
			Database.Close();
			Database.ReleaseDispatch();
		}
		else
		{
			AfxMessageBox("Unable to open the database");
		}		
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnListContacts() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnListContacts ");
	}
}

// List all groups
void CActclientDlg::OnListGroups() 
{
	try
	{
		COleException *pException;

		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");

		m_ListBox.ResetContent();

		if( Database.GetIsOpen() )			
		{										
			// Get & Attach Group Object
			IGroup Group;
			LPDISPATCH groupDispatch = Database.GetGroup();
			Group.AttachDispatch(groupDispatch, TRUE);
			
			m_ListBox.AddString("----------------------");				
			m_ListBox.AddString("List of Groups");					
			m_ListBox.AddString("----------------------");				
			// Start enumerating all of the groups
			Group.MoveFirst();						
			while( !Group.GetIsEOF() )
			{
				CString szOutput;
				ConvertVariantToString (Group.GetData(GF_Name), szOutput);
				m_ListBox.AddString( szOutput );	
				Group.MoveNext();			
			}

			m_ListBox.AddString("----------------------");				

			// Release Group Object
			Group.ReleaseDispatch();
												
			// Close & Release Database
			Database.Close();
			Database.ReleaseDispatch();
		}
		else
		{
			AfxMessageBox("Unable to open the database");
		}		
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnListGroups() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnListGroups ");
	}	
}


// Converts the variant to a string value	
void CActclientDlg::ConvertVariantToString( VARIANT varNewValue, CString &retString)
{
	COleVariant oleVariant( varNewValue );	

	if( oleVariant.vt != VT_BSTR )
	{
		COleVariant oleTemp( varNewValue );
		oleVariant.ChangeType(VT_BSTR, (COleVariant*) &oleTemp);
	}

	retString = oleVariant.bstrVal;	
}
	

void CActclientDlg::OnListContactsForGroup() 
{	
	
	try
	{		
		COleException *pException;

		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");

		m_ListBox.ResetContent();

		if( Database.GetIsOpen() )			
		{							
			// Attach to the GROUP object
			IGroup Group;
			LPDISPATCH groupDispatch = Database.GetGroup();
			Group.AttachDispatch(groupDispatch, TRUE);
			
			// enumerate all of the GROUPS
			Group.MoveFirst();			
			
			while( !Group.GetIsEOF() )
			{
				CString szOutput, szOutput1;								
				
				ConvertVariantToString( Group.GetData(GF_Name), szOutput);
				szOutput1 = "Group Name:" + szOutput;
				m_ListBox.AddString( szOutput1 );			
				
				// If there are contacts for this group enumerate them
				if( Group.GetContactCount() > 0 )
				{
					m_ListBox.AddString( "Members:" );
					// Attach to the MEMBERS object
					IMembers Members;
					LPDISPATCH membersDispatch = Group.GetMembers();
					Members.AttachDispatch(membersDispatch, TRUE);

					// List All Members
					Members.MoveFirst();
					while( !Members.GetIsEOF() )
					{
						CString memberString;
						memberString.Format("--> %s", Members.GetName());
						m_ListBox.AddString(memberString);

						Members.MoveNext();
					}
					// Release Members Object
					Members.ReleaseDispatch();
				}
				Group.MoveNext();			
			}
			// Release Group Object
			Group.ReleaseDispatch();												

			// Close & Release Database
			Database.Close();
			Database.ReleaseDispatch();
		}
		else
		{
			AfxMessageBox("Unable to open the database");
		}		
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnListContactsForGroup() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnListContactsForGroup ");
	}		
}


// list all Activities
void CActclientDlg::OnListActivities() 
{
	try
	{
		COleException *pException;

		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");

		m_ListBox.ResetContent();

		if( Database.GetIsOpen() )			
		{										
			// Attach to the GROUP object
			IActivity Activity;
			LPDISPATCH activityDispatch = Database.GetActivity();
			Activity.AttachDispatch(activityDispatch, TRUE);
						
			Activity.MoveFirst();			
			
			int recCount = 1;
			long totalrecCount = Activity.GetRecordCount();

			m_ListBox.AddString("----------------------");				
			m_ListBox.AddString("List of Activities");					
			m_ListBox.AddString("----------------------");				
			while( !Activity.GetIsEOF() )
			{
				CString szOutput;
            
				// Format the start time/date for output
				COleDateTime oleDateTime( Activity.GetData(AF_StartTime) );
				szOutput = oleDateTime.Format("%c");
				szOutput = "Start Time : " + szOutput;
				m_ListBox.AddString( szOutput );

				ConvertVariantToString( Activity.GetData(AF_StartTime), szOutput);
				szOutput = "Start Time (as string) : " + szOutput;            
				m_ListBox.AddString( szOutput );
                                
				ConvertVariantToString( Activity.GetData(AF_TimelessStatus), szOutput);
				szOutput = "Timeless : " + szOutput;            
				m_ListBox.AddString( szOutput );

				ConvertVariantToString( Activity.GetData(AF_Regarding), szOutput);
				szOutput = "Regarding : " + szOutput;
				m_ListBox.AddString( szOutput );			

				m_ListBox.AddString("------------------");
						
				Activity.MoveNext();							
			}			

			// Release Activity Object
			Activity.ReleaseDispatch();
														
			// Close & Release Database
			Database.Close();
			Database.ReleaseDispatch();
		}
		else
		{
			AfxMessageBox("Unable to open the database");
		}		
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnListActivities() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnListActivities ");
	}	
}

void CActclientDlg::OnAddEmail() 
{
	try
	{		
		COleException *pException;

		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");
    
		m_ListBox.ResetContent();

		if( Database.GetIsOpen() )			
		{	
			// Get & Attach to the Contact object
			IContact Contact;
			LPDISPATCH contactDispatch = Database.GetContact();
			Contact.AttachDispatch(contactDispatch, TRUE);
			Contact.MoveFirst();

			// Pick a contact record at random
			int nCount = Contact.GetRecordCount();
			srand (GetTickCount());
			int nPos = rand() % nCount;
			Contact.Jump (nPos);
			//Generate a random email address
			TCHAR EMailAddress[100];
			sprintf (EMailAddress, "User%d@Symantec.Com", rand());

			CString contactUniqueID = "";
			CString contactName = "";
			ConvertVariantToString( Contact.GetData(CF_UniqueID), contactUniqueID);
			ConvertVariantToString( Contact.GetData(CF_Name), contactName);                  

				CString Msg = "Adding E-Mail address to contact " + contactName;
				m_ListBox.AddString( Msg );

				// Get & Attach to the Email object
				IEmail Email;
				LPDISPATCH emailDispatch = Database.GetEmail();
				Email.AttachDispatch(emailDispatch, TRUE);
					
				Email.MoveFirst();

				// Add an e-mail address to the first contact list
				Email.Add();                       
				Email.SetData( EF_ContactId, COleVariant(contactUniqueID) );  //Link to contact
				Email.SetData( EF_Logon, COleVariant(EMailAddress) );
				Email.SetData( EF_PrimaryStatus, COleVariant("0") );
				Email.SetData( EF_Carrier, COleVariant("1"));

				// Unique Id of the record just added
				CString uniqueID = "";
				uniqueID = Email.Update();

				m_ListBox.AddString( "Email Address Added:" );
				m_ListBox.AddString( EMailAddress );

			// Release E-Mail Object
			Email.ReleaseDispatch();

			// Release Contact Object
			Contact.ReleaseDispatch();

			// Close & Release Database
			Database.Close();
			Database.ReleaseDispatch();
		}
		else
		{
			AfxMessageBox("Unable to open the database");
		}		
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnAddEmail() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnAddEmail ");
	}			
}



void CActclientDlg::OnAdduser() 
{
	try
	{
		COleException *pException;
        m_ListBox.ResetContent();
		CString sVersion ;
		CString sContactId ;
		int nVer ;
		BOOL bAdd ;
		// Create & Open Database Object
		IDatabase Database;									
		Database.CreateDispatch("ACTOLE.DATABASE", pException);			
		Database.Open("c:\\Program Files\\Symantec\\act\\database\\act5demo.dbf");
        sVersion = Database.GetVersion() ;  //Get the Version of the Database Object
		sscanf( sVersion, "%d", &nVer );
		if (nVer >= 4)   // Check if Version is at least 4.0
		{
			if( Database.GetIsOpen() )			
			{							
				// Get & Attach Contact Object
				IContact Contact;
				LPDISPATCH contactDispatch = Database.GetContact();
				Contact.AttachDispatch(contactDispatch, TRUE);
				// Get & Attach Users Object
				IUsers User;
				LPDISPATCH userDispatch = Database.GetUsers();
				User.AttachDispatch(userDispatch, TRUE);

				m_ListBox.AddString("----------------------");				
				m_ListBox.AddString("Adding a User - Mary Smith");					
				m_ListBox.AddString("----------------------");	
				
				//Adding a New User "Mary Smith" with "standard"(3) security level
				bAdd = User.AddUser ("Mary Smith" ,"password" , 3);
				m_ListBox.AddString("New User...Mary Smith added.....");	
				if (bAdd)
				{
					//Add a new Contact
					Contact.Add() ;
					Contact.SetData(CF_Name,COleVariant("Mary Smith"));
					Contact.SetData(CF_Company,COleVariant("My Company"));
					sContactId = Contact.Update() ;
					m_ListBox.AddString("New Contact Mary Smith Created.");
					//New Contact Mary Smith Created
					Contact.GoTo (sContactId);
					//Set this newly added Contact as the My Record for Mary Smith -the User
					Contact.SetAsMyRecord("Mary Smith") ;
					m_ListBox.AddString("Mary Smith has a My Record.");
				
				}
				else
				{
					m_ListBox.AddString("Error Adding Mary Smith as User.");
					m_ListBox.AddString("Verify the database is not isn use by some other application( including ACT!)");
				}


				User.ReleaseDispatch();
				// Release Contact Object
				Contact.ReleaseDispatch();

				// Close & Release Database
				Database.Close();
				Database.ReleaseDispatch();
			}
			else
			{
			AfxMessageBox("Unable to open the database");
			}		
		}
		else
		{
			AfxMessageBox("You need at least ACT! 4.0 to execute this. Please Upgrade!");
		}
	}
	catch(...)
	{
		TRACE("Detected Exception in CActcliDlg::OnListContacts() \n");		
		AfxMessageBox("Detected Exception in CActcliDlg::OnListContacts ");
	}
}
